/* **********************************************************************
*Copyright (C) 2003 Elliott Michell					*
*Elliott Mitchell takes no responsibility for failures, or damage done	*
*by this program.							*
*									*
*$Id: xwing.c,v 3.2 2003/10/01 03:54:51 ehem Rel $			*
************************************************************************/

#include <stdlib.h>
#include <unistd.h>
#include <math.h>
#include <X11/Xlib.h>
#include <X11/extensions/Xdbe.h>
#include <gdk/gdkx.h>
#include <gtk/gtk.h>

#include <signal.h>
#include <time.h>
#include <sys/time.h>
#include <sys/types.h>
#include <stdio.h>

#include <X11/extensions/multibuf.h>



#define IERR fprintf(stderr, "Internal Error #%d\n", __LINE__);
#define IFAT do { fprintf(stderr, "Internal Error #%d! (fatal) \n", __LINE__); \
exit(1); } while(0)

#define WINDOW_HEIGHT 200
#define WINDOW_WIDTH WINDOW_HEIGHT*6
#define WINDOW_HEIGHT_RATIO .8

#define WING_HEIGHT_WIDTH_RATIO .25
#define WING_BEND_ANGLE 15

#define WING_ANGLE_SPEED .1 /*degrees/sec*/

#define WING_SPEED_SEC 0
#define WING_SPEED_USEC 100000

#define chksel do { if(!sel) return; } while(0)


struct {
	Display *dpy;
	Visual *vis;
	GC gc, cleargc, sailgc;
	unsigned long fore, back;
	unsigned long h, w;
	unsigned mbuf:1;
	int mbuf_evnt, mbuf_err;
} Xglob={NULL, NULL, NULL, NULL, NULL, 0, 0, WINDOW_HEIGHT, WINDOW_WIDTH, 0, 0,
0, };

struct aspair {
	GtkAdjustment *mn, *mx;
};

struct {
#define GTKUI_ADJ_SH 0x2
	struct aspair sh;
#define GTKUI_ADJ_EL 0x4
	struct aspair el;
#define GTKUI_ADJ_FF 0x6
	struct aspair ff;
#define GTKUI_ADJ_NF 0x8
	struct aspair nf;
#define GTKUI_ADJ_FB 0xA
	struct aspair fb;

#define GTKUI_ADJ_AL 0xC
	GtkAdjustment *nlen, *flen;
#define GTKUI_ADJ_FL 0xE
	GtkAdjustment *fnlen, *fflen;

#define GTKUI_ADJ_BN 0x0
	GtkAdjustment *bmn, *bmx;

	GtkToggleButton *selb;
} gtkglob;


struct angset {
	double mn, mx;
};

struct wingset {
	Window win;
	XdbeBackBuffer backbuf;
	struct wingset *fore, *back;
	unsigned en:1, drawing:1; /*enable, fill in the wings*/
	unsigned long h, w;
	unsigned by, bx, bh, bw; /*Body X, Y, Height, and Width*/
	/*unsigned long*/ double nlen, flen;
	/*unsigned long*/ double fnlen, fflen; /*finger lengths*/
	double cycle;	/*animation loop counter (linear 0.0->1.0)*/
	double outang;	/*how far out is it? (percentage 0.0<outang<1.0)*/

	struct angset sh, el, fb, ff, nf;


	double shang, elang, fbang, ffang, nfang;
	double leadbase, midbase, baseang;


	XPoint jl, jr; /*shoulder Joint Left, and Right*/

	XSegment lwing[10];
	XSegment rwing[10];

	XPoint lfwing[5], lmwing[5], lnwing[6];
	XPoint rfwing[5], rmwing[5], rnwing[6];
};
/* 616 bytes at maximum at 2.113, 288 bytes in X structure arrays */

unsigned dnum=0;
struct {
	struct wingset *fore, *back;
} wglob={NULL, NULL};

GHashTable *wtable=NULL;

double mtime=0, aspd=.1;

struct timeval spd={0, 100000};
struct wingset *sel;

volatile long ecnt=0;


/*void shutdown();*/

gint doframe();

int Xstartup(), Xshutdown(int), openwin(Window *, unsigned, unsigned),
closewin(Window *), Xhandler(Display *, XEvent *);

void die() {
	Xshutdown(1);
}

int newwings(unsigned, unsigned, double, double, double, double, double,
double, double, double, double, double, double, double, double, double);
int freewings(struct wingset *);

int genwings(double, struct wingset *);

void setui(struct wingset *);


static void startgtkui(void);
static GdkFilterReturn eventcall(GdkXEvent *);
static void newdrwin(void), deldrwin(void);
/*static void selcall(GtkToggleButton *);*/
static void slidecall(GtkAdjustment *, int);



int main(int argc, char *argv[])
{

/*	int mxfd=2;
	fd_set nullset, rset;


	struct itimerval tval;
	struct timeval delay={0, 10000}, *delayp=&delay;*/


#ifdef DEBUG
	printf("sizeof(gtkglob)=%d\n", sizeof(gtkglob));
	printf("sizeof(Xglob)=%d\n", sizeof(Xglob));
	printf("sizeof(XPoint)=%d\n", sizeof(XPoint));
	printf("sizeof(XSegment)=%d\n", sizeof(XSegment));
	printf("sizeof(XPoint[5])=%d\n", sizeof(XPoint[5]));
	printf("sizeof(XSegment[10])=%d\n", sizeof(XSegment[10]));
	printf("sizeof(struct wingset)=%d\n", sizeof(struct wingset));
#endif

/*	atexit(shutdown);*/

/*	signal(SIGINT, die);

	FD_ZERO(&nullset);
	FD_ZERO(&rset);*/

	/*initialization stuff*/

	wtable=g_hash_table_new(NULL, NULL);

	gtk_init(&argc, &argv);

	gdk_window_add_filter(NULL, (GdkFilterFunc)eventcall, NULL);

	Xstartup();

	startgtkui();


#define toang(ang) ((ang)*M_PI/180)
	newwings(WINDOW_HEIGHT, WINDOW_WIDTH, 80, 80, 81, 81,
toang(82.5), toang(4), toang(15), toang(180), toang(15), toang(15),
toang(15), toang(175), toang(90), toang(176));
#undef toang

	sel=wglob.fore;
	setui(sel);

/*	signal(SIGALRM, doframe);
	setitimer(ITIMER_REAL, &tval, NULL);*/


/*	signal(SIGINT, sighndl);*/

/*	if(mxfd<=ConnectionNumber(Xglob.dpy))
mxfd=ConnectionNumber(Xglob.dpy)+1;*/

/*	do {
		FD_SET(ConnectionNumber(fl_display), &rset);
		if(!XEventsQueued(fl_display, QueuedAfterReading)&&!select(mxfd,
&rset, &nullset, &nullset, &delay)) {*/
			/*fprintf(stderr, "Reloading Counter\n");*/
/*			if((spd.tv_sec==0)&&(spd.tv_usec==0)) {
				delayp=NULL;
			} else {
				delayp=&delay;
				delay.tv_sec=spd.tv_sec;
				delay.tv_usec=spd.tv_usec;
				doframe();
			}
		} else {*/
/*			fprintf(stderr, "Processing Event\n");*/
/*			active=fl_check_forms();
			while(active==FL_EVENT) {*/
/*				fprintf(stderr, "Processing XWing Event\n");*/
/*				fl_XNextEvent(&ev);
				Xhandler(Xglob.dpy, &ev);

				active=fl_check_forms();
			}
		}
	} while(active!=qform->quit);*/

	gtk_timeout_add(100, (GtkFunction)doframe, NULL);

	gtk_main();


	while(wglob.fore!=NULL) freewings(wglob.fore);

/*	XFlush(Xglob.dpy);*/

	Xshutdown(0);

#ifdef DEBUG
	fprintf(stderr, "Exiting from main function\n");

	fprintf(stderr, "Normal exit\n"); /* %d evnts in start\n", loop);*/
#endif

	return(0);
}

/*Where the heck does XSetCloseDownMode get called?!*/
/*void shutdown()
{
	struct itimerval tval={{0, 0}, {0, 0}};
	signal(SIGALRM, SIG_IGN);
	setitimer(ITIMER_REAL, &tval, NULL);

	fprintf(stderr, "Abnormal exit!\n");

	dlink=wglob.fore;
	while(dlink!=NULL) {
		wglob.fore=dlink->fore;
		freewings(dlink);
		dlink=wglob.fore;
	}

	Xshutdown(0);

	Xshutdown(1);
}*/


static void genaspair(GtkBox *, const gchar *, GtkAdjustment *,
GtkAdjustment *, int);

static void startgtkui(void)
{
	GtkWidget *window, *w;
	GtkBox *bx0, *bx1, *bx;


	bx0=GTK_BOX(gtk_vbox_new(FALSE, 5));


	bx=GTK_BOX(gtk_hbox_new(TRUE, 0));

#define NAA() GTK_ADJUSTMENT(gtk_adjustment_new(0, 0, 180, 1, 15, 0))

	genaspair(bx, "shoulder", gtkglob.sh.mn=NAA(), gtkglob.sh.mx=NAA(),
GTKUI_ADJ_SH);
	genaspair(bx, "elbow", gtkglob.el.mn=NAA(), gtkglob.el.mx=NAA(),
GTKUI_ADJ_EL);
	genaspair(bx, "finger angle", gtkglob.ff.mn=NAA(), gtkglob.ff.mx=NAA(),
GTKUI_ADJ_FF);
	genaspair(bx, "near finger angle",gtkglob.nf.mn=NAA(),
gtkglob.nf.mx=NAA(), GTKUI_ADJ_NF);
	genaspair(bx, "finger bend", gtkglob.fb.mn=NAA(), gtkglob.fb.mx=NAA(),
GTKUI_ADJ_FB);

	genaspair(bx, "arm length", gtkglob.nlen=NAA(), gtkglob.flen=NAA(),
GTKUI_ADJ_AL);
	genaspair(bx, "finger length", gtkglob.fnlen=NAA(),
gtkglob.fflen=NAA(), GTKUI_ADJ_FL);
	genaspair(bx, "bends", gtkglob.bmn=NAA(), gtkglob.bmx=NAA(),
GTKUI_ADJ_BN);

#undef NAA

	gtk_widget_show(GTK_WIDGET(bx));
	gtk_box_pack_start(bx0, GTK_WIDGET(bx), TRUE, TRUE, 0);


	bx1=GTK_BOX(gtk_hbox_new(FALSE, 0));

	bx=GTK_BOX(gtk_hbox_new(TRUE, 0));
	w=gtk_button_new_with_label("New");
	g_signal_connect(G_OBJECT(w), "clicked", G_CALLBACK(newdrwin), NULL);
	gtk_box_pack_start(bx, w, TRUE, TRUE, 0);
	gtk_widget_show(w);
	w=gtk_button_new_with_label("Delete");
	g_signal_connect(G_OBJECT(w), "clicked", G_CALLBACK(deldrwin), NULL);
	gtk_box_pack_start(bx, w, TRUE, TRUE, 0);
	gtk_widget_show(w);
	gtk_widget_show(GTK_WIDGET(bx));
	gtk_box_pack_start(bx1, GTK_WIDGET(bx), TRUE, FALSE, 0);

	bx=GTK_BOX(gtk_hbox_new(FALSE, 0));
	w=gtk_toggle_button_new_with_label("select");
	gtkglob.selb=GTK_TOGGLE_BUTTON(w);
	gtk_box_pack_start(bx, w, FALSE, FALSE, 10);
	gtk_widget_show(w);
	gtk_widget_show(GTK_WIDGET(bx));
	gtk_box_pack_start(bx1, GTK_WIDGET(bx), TRUE, FALSE, 0);

	w=gtk_button_new_with_label("Quit");
	g_signal_connect(G_OBJECT(w), "clicked", G_CALLBACK(gtk_main_quit),
NULL);
	gtk_widget_show(w);
	gtk_box_pack_end(bx1, w, FALSE, FALSE, 0);

	gtk_widget_show(GTK_WIDGET(bx1));
	gtk_box_pack_end(bx0, GTK_WIDGET(bx1), FALSE, FALSE, 0);


	window=gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title(GTK_WINDOW(window), "XWing");
	g_signal_connect(G_OBJECT(window), "destroy", G_CALLBACK(gtk_main_quit),
NULL);

	gtk_container_set_border_width(GTK_CONTAINER(window), 5);

	gtk_container_add(GTK_CONTAINER(window), GTK_WIDGET(bx0));
	gtk_widget_show(GTK_WIDGET(bx0));

	gtk_widget_show(window);

	return;
}

static void genaspair(GtkBox *box, const gchar *name, GtkAdjustment *lo,
GtkAdjustment *hi, int adjval)
{
	GtkWidget *aspair, *fr, *wk;
	gint x, y;

	aspair=gtk_frame_new(name);

	gtk_frame_set_label_align(GTK_FRAME(aspair), 0.5, 0.0);
	gtk_frame_set_shadow_type(GTK_FRAME(aspair), GTK_SHADOW_NONE);

	fr=gtk_hbox_new(TRUE, 0);

	gtk_container_add(GTK_CONTAINER(aspair), fr);

	wk=gtk_vscale_new(lo);
	g_signal_connect(G_OBJECT(lo), "value_changed", G_CALLBACK(slidecall),
(gpointer)adjval);
	gtk_scale_set_draw_value(GTK_SCALE(wk), TRUE);
	gtk_scale_set_digits(GTK_SCALE(wk), 0);
	gtk_scale_set_value_pos(GTK_SCALE(wk), GTK_POS_LEFT);
	gtk_range_set_inverted(GTK_RANGE(wk), TRUE);
	gtk_box_pack_start(GTK_BOX(fr), wk, TRUE, FALSE, 0);
	gtk_widget_get_size_request(wk, &x, &y);
	gtk_widget_set_size_request(wk, x, 220);
	gtk_widget_show(wk);

	wk=gtk_vscale_new(hi);
	g_signal_connect(G_OBJECT(hi), "value_changed", G_CALLBACK(slidecall),
(gpointer)(adjval|1));
	gtk_scale_set_draw_value(GTK_SCALE(wk), TRUE);
	gtk_scale_set_digits(GTK_SCALE(wk), 0);
	gtk_scale_set_value_pos(GTK_SCALE(wk), GTK_POS_RIGHT);
	gtk_range_set_inverted(GTK_RANGE(wk), TRUE);
	gtk_box_pack_end(GTK_BOX(fr), wk, TRUE, FALSE, 0);
	gtk_widget_get_size_request(wk, &x, &y);
	gtk_widget_set_size_request(wk, x, 220);
	gtk_widget_show(wk);

	gtk_widget_show(fr);

	gtk_box_pack_start(box, aspair, TRUE, FALSE, 0);
	gtk_widget_show(aspair);
}


static void newdrwin(void)
{
	newwings(WINDOW_HEIGHT, WINDOW_WIDTH, sel->nlen, sel->flen,
sel->fnlen, sel->fflen, sel->sh.mx, sel->sh.mn, sel->el.mx, sel->el.mn,
sel->fb.mx, sel->fb.mn, sel->ff.mx, sel->ff.mn, sel->nf.mx, sel->nf.mn);

#ifdef DEBUG
	printf("Creation\n");
#endif

	sel=wglob.back;
	setui(sel);
}

static void deldrwin(void)
{
	/*chksel;*/

	if(sel!=NULL) {
		if(dnum<=1) {
#ifdef DEBUG
			fprintf(stderr, "No Delection (one left)\n");
#endif
			return;
		}
		freewings(sel);

#ifdef DEBUG
		fprintf(stderr, "Deletion\n");
#endif
	} else IERR;
}

static void slidecall(GtkAdjustment *sld, int opt)
{
	const char *selstr;
	struct angset *ang=NULL;
	struct aspair *as=NULL;

	if(!sel) return;

	switch(opt&~1) {
	case GTKUI_ADJ_SH:
		selstr="shoulder";
		as=&gtkglob.sh;
		ang=&sel->sh;
	break;
	case GTKUI_ADJ_EL:
		selstr="elbow";
		as=&gtkglob.el;
		ang=&sel->el;
	break;
	case GTKUI_ADJ_FF:
		selstr="far finger";
		as=&gtkglob.ff;
		ang=&sel->ff;
	break;
	case GTKUI_ADJ_NF:
		selstr="near finger";
		as=&gtkglob.nf;
		ang=&sel->nf;
	break;
	case GTKUI_ADJ_FB:
		selstr="finger bend";
		as=&gtkglob.fb;
		ang=&sel->fb;
	break;

	case GTKUI_ADJ_AL:
		selstr="arm length";
		if(opt&1) sel->flen=gtkglob.flen->value;
		else sel->nlen=gtkglob.nlen->value;
	break;
	case GTKUI_ADJ_FL:
		selstr="finger length";
		if(opt&1) sel->fflen=gtkglob.fflen->value;
		else sel->fnlen=gtkglob.fnlen->value;
	break;

	case GTKUI_ADJ_BN:
		selstr="bend";
		/*setaa*/
	break;

	default:
		IERR;
	break;
	}

	if(as) {
		if(opt&1) ang->mx=as->mx->value*M_PI/180;
		else ang->mn=as->mn->value*M_PI/180;
	}

	return;
}

static GdkFilterReturn eventcall(GdkXEvent *event)
{
	int ret;

	if((ret=Xhandler(Xglob.dpy, (XEvent *)event))) {
		if(ret<0) IERR;
		return(GDK_FILTER_REMOVE);
	}

	return(GDK_FILTER_CONTINUE);
}

void setui(struct wingset *wing)
{

	gtk_adjustment_set_value(gtkglob.nlen, wing->nlen);
	gtk_adjustment_set_value(gtkglob.flen, wing->flen);
	gtk_adjustment_set_value(gtkglob.fnlen, wing->fnlen);
	gtk_adjustment_set_value(gtkglob.fflen, wing->fflen);

/*	len=wing->nlen+wing->flen+wing->fnlen+wing->fflen;
	len*=0.25; **divide 4**

	setpair(len, bnd);*/


	gtk_adjustment_set_value(gtkglob.sh.mn, wing->sh.mn*180.0/M_PI);
	gtk_adjustment_set_value(gtkglob.sh.mx, wing->sh.mx*180.0/M_PI);
	gtk_adjustment_set_value(gtkglob.el.mn, wing->el.mn*180.0/M_PI);
	gtk_adjustment_set_value(gtkglob.el.mx, wing->el.mx*180.0/M_PI);
	gtk_adjustment_set_value(gtkglob.fb.mn, wing->fb.mn*180.0/M_PI);
	gtk_adjustment_set_value(gtkglob.fb.mx, wing->fb.mx*180.0/M_PI);

	gtk_adjustment_set_value(gtkglob.ff.mn, wing->ff.mn*180.0/M_PI);
	gtk_adjustment_set_value(gtkglob.ff.mx, wing->ff.mx*180.0/M_PI);
	gtk_adjustment_set_value(gtkglob.nf.mn, wing->nf.mn*180.0/M_PI);
	gtk_adjustment_set_value(gtkglob.nf.mx, wing->nf.mx*180.0/M_PI);
}


/*void callcorr(FL_OBJECT *obj, long data)
{
**	char *str;**
	double aa, al;
	double fa, fl;
	double sa, final;

	chksel;

	switch(fl_get_menu(obj)) {
	case 1:
**		str="Shoulder";**

		aa=atan((sel->flen*sin(sel->el.mx))/
(sel->nlen+sel->flen*cos(sel->el.mx)));
		al=sin(sel->el.mx)/sin(aa)*sel->flen;
		fa=atan((sel->fflen*sin(sel->fb.mx))/
(sel->fnlen+sel->fflen*cos(sel->fb.mx)));
		fl=sin(sel->fb.mx)/sin(fa)*sel->fflen;
		sa=acos((sel->bh-fl)*.5/al);
		final=sa-aa;

		sel->sh.mx=final;
	break;
	case 2:
**		str="Elbow";**

		fa=atan((sel->fflen*sin(sel->fb.mx))/
(sel->fnlen+sel->fflen*cos(sel->fb.mx)));
		final=sel->sh.mx+sel->el.mx-fa;

		sel->nf.mx=final;
	break;
	case 3:
**		str="Finger";**

		fa=atan((sel->fflen*sin(sel->fb.mx))/
(sel->fnlen+sel->fflen*cos(sel->fb.mx)));
		fl=sin(sel->fb.mx)/sin(fa)*sel->fflen;
		final=sel->bh/fl;

		sel->fnlen*=final;
		sel->fflen*=final;

		sel->fb.mn=sel->fb.mx;
	break;
	default:
		IERR;
	break;
	}

**	printf("%s Correction (unimplemented)\n", str);**
	setui(sel);
}*/


int Xstartup()
{
	Display *dpy;
	Window win=0;
	XGCValues xgcv;
	XEvent xev;
	XColor color, garbagecolor;

	int status;

	dpy=Xglob.dpy=gdk_x11_get_default_xdisplay();

/*	XSynchronize(dpy, 1);*/
	Xglob.fore=BlackPixel(dpy, DefaultScreen(dpy));
	Xglob.back=WhitePixel(dpy, DefaultScreen(dpy));
	if(!(win=XCreateSimpleWindow(dpy, DefaultRootWindow(dpy), 0, 0,
Xglob.w, Xglob.h, 0, 0, Xglob.back))) {
		fprintf(stderr, "XCreateSimpleWindow failed! return=%x\n",
(int)win);
		return(2);
	}

	xgcv.foreground=Xglob.fore;
	xgcv.background=Xglob.back;
	if(XAllocNamedColor(dpy, DefaultColormap(dpy, DefaultScreen(dpy)),
"red", &color, &garbagecolor)!=True) {
		fprintf(stderr, "Unable to grab color \"red\"!\n");
		exit(20);
	}

	xgcv.line_width=1;
	xgcv.line_style=LineSolid;
	xgcv.cap_style=CapProjecting;
	xgcv.join_style=JoinBevel;
	xgcv.fill_style=FillSolid;
	xgcv.plane_mask=0xFFFFFFFF;
	xgcv.function=GXcopy;
	if(!(Xglob.gc=XCreateGC(dpy, win, GCForeground|GCBackground|
GCLineWidth|GCLineStyle|GCJoinStyle|GCFillStyle|GCPlaneMask|GCFunction,
&xgcv))) {
		fprintf(stderr, "XCreateGC failed! return=%x\n", (int)Xglob.gc);
		return(3);
	}

	xgcv.foreground=Xglob.back;
	xgcv.background=Xglob.back;
	if(!(Xglob.cleargc=XCreateGC(dpy, win, GCForeground|GCBackground|
GCLineWidth|GCLineStyle|GCJoinStyle|GCFillStyle|GCPlaneMask|GCFunction,
&xgcv))) {
		fprintf(stderr, "XCreateGC failed(clear)! return=%x\n",
(int)Xglob.cleargc);
		return(3);
	}


	xgcv.background=color.pixel;
	xgcv.foreground=color.pixel;
	if(!(Xglob.sailgc=XCreateGC(dpy, win, GCForeground|GCBackground|
GCLineWidth|GCLineStyle|GCJoinStyle|GCFillStyle|GCPlaneMask|GCFunction,
&xgcv))) {
		fprintf(stderr, "XCreateGC(sail) failed! return=%x\n",
(int)Xglob.sailgc);
		return(3);
	}

	XDestroyWindow(dpy, win); win=0;

	Xglob.mbuf=XmbufQueryExtension(dpy, &Xglob.mbuf_evnt, &Xglob.mbuf_err);

	if(Xglob.mbuf) {
		int maj, min;
		XmbufGetVersion(dpy, &maj, &min);
#ifdef DEBUG
		fprintf(stderr, "X Multi-Buffer present major=%d, minor=%d\n",
maj, min);
	} else fprintf(stderr, "X Multi-Buffer Extension absent\n");
#else
	}
#endif

	{
		int min, maj;
		Xglob.mbuf=XdbeQueryExtension(dpy, &maj, &min)==True;
#ifdef DEBUG
		if(Xglob.mbuf) fprintf(stderr, "X Double-Buffer present "
"major=%d, minor=%d\n", maj, min);
		else fprintf(stderr, "X Double-Buffer Extension absent\n");
#endif
	}

	return(0);
}

int Xshutdown(int level)
{
	Display *dpy=Xglob.dpy;

	if(Xglob.gc) {
		XFreeGC(dpy, Xglob.gc);
		Xglob.gc=NULL;
	}
	if(Xglob.cleargc) {
		XFreeGC(dpy, Xglob.cleargc);
		Xglob.cleargc=NULL;
	}
	if(Xglob.sailgc) {
		XFreeGC(dpy, Xglob.sailgc);
		Xglob.sailgc=NULL;
	}

	while(wglob.fore) freewings(wglob.fore);

	if(level) {
		if(Xglob.dpy!=NULL) {
			XCloseDisplay(dpy);
			dpy=Xglob.dpy=NULL; /*********************************/
			fprintf(stderr, "Warning Display forced closed!\n");
		}
	}

#ifdef DEBUG
	fprintf(stderr, "%ld XWing events occured\n", ecnt);
#endif
	return(0);
}


int openwin(Window *win, unsigned w, unsigned h)
{
	Display *dpy=Xglob.dpy;
	XEvent xev;

	int maj, min;

	if(dpy==NULL) IERR;

	if(*win!=0) {
		fprintf(stderr, "Error: Trying to open already open window!\n");
		return(0);
	}

	if(!(*win=XCreateSimpleWindow(dpy, DefaultRootWindow(dpy), 0, 0, w, h,
0, 0, Xglob.back))) {
		fprintf(stderr, "XCreateSimpleWindow failed! return=%x\n",
(int)win);
		exit(10);
	}

	XMapWindow(dpy, *win);
	XSelectInput(dpy, *win, ExposureMask|ButtonPressMask);
	XFlush(dpy);
	return(1);
}

int closewin(Window *win)
{
	Display *dpy=Xglob.dpy;
	if(*win==0) {
		fprintf(stderr, "Warning! Trying to close already closed "
"window!\n");
		return(0);
	}
	XUnmapWindow(dpy, *win);
	XDestroyWindow(dpy, *win);
	*win=0;
	return(1);
}


int Xhandler(Display *dpy, XEvent *xev)
{
	struct wingset *wing;
	XID id;


	id=xev->xany.window;
/*	id=gdk_x11_drawable_get_xid(xev->any.window);*/


	if(!(wing=g_hash_table_lookup(wtable, (gpointer)id))) return(0);


	++ecnt;

	switch(xev->xany.type) {
	case EnterNotify:
/*		XSelectInput(Xglob.dpy, sel->win, ExposureMask|EnterWindowMask|
LeaveWindowMask|ButtonPressMask|ButtonReleaseMask);*/
/*		fprintf(stderr, "Menter\n");*/
	break;
	case LeaveNotify:
/*		XSelectInput(Xglob.dpy, sel->win, ExposureMask|EnterWindowMask|
LeaveWindowMask);*/
/*		fprintf(stderr, "Mexit\n");*/
	break;
	case ButtonPress:
	case ButtonRelease:
		if(gtk_toggle_button_get_active(gtkglob.selb)) {
#ifdef DEBUG
			fprintf(stderr, "Window selected\n");
#endif

			sel=wing;
			setui(wing);

			gtk_toggle_button_set_active(gtkglob.selb, FALSE);
		}
#ifdef DEBUG
		else fprintf(stderr, "Window clicked (selection off)\n");
#endif
	break;
	case Expose:
		/*Nothing*/
		wing->en=1;
	break;
	default:
		fprintf(stderr, "Unknown event occured on XWing window!\b\n");
	break;
	}

	return(1);
}


int newwings(unsigned h, unsigned w,
double nlen, double flen, double fnlen, double fflen,
double shmxang, double shmnang, double elmxang, double elmnang, double fbmxang,
double fbmnang, double ffmxang, double ffmnang, double nfmxang, double nfmnang)
{
	double bang=shmxang;
	struct wingset *wing;

	wing=(struct wingset *)malloc(sizeof(struct wingset));
	if(!wing) {
		fprintf(stderr, "Oops! I'm senile!\n");
		exit(1);
	}
	wing->win=0;

	wing->fore=NULL;
	if(wglob.fore) {
		wing->back=wglob.back;
		wglob.back->fore=wing;
		wglob.fore->back=wing;
	} else {
		wing->back=wing;
		wglob.fore=wing;
	}
	wglob.back=wing;

	++dnum;


	/*wingset initialization stuff*/

	wing->en=0;

	openwin(&wing->win, w, h);
	g_hash_table_insert(wtable, (gpointer)wing->win, wing);
	if(Xglob.mbuf) {
		char estr[256];
		wing->backbuf=XdbeAllocateBackBufferName(Xglob.dpy, wing->win,
XdbeUndefined);

		if(wing->backbuf<=LastExtensionError) {
			XGetErrorText(Xglob.dpy, wing->backbuf, estr, 256);
			fprintf(stderr, "XdbeAllocateBackBufferName returned "
"%s!\n", estr);
			wing->backbuf=0;
		}
	} else wing->backbuf=0;

	wing->bh=h*WINDOW_HEIGHT_RATIO;
	wing->bw=h*WING_HEIGHT_WIDTH_RATIO;
	wing->by=(h-wing->bh)/2;
	wing->bx=(w-wing->bw)/2;

	wing->jl.y=wing->by;
	wing->jl.x=wing->bx;
	wing->jr.y=wing->by;
	wing->jr.x=wing->bx+wing->bw;

	wing->lnwing[1].x=wing->jl.x;
	wing->lnwing[1].y=wing->jl.y;
	wing->rnwing[1].x=wing->jr.x;
	wing->rnwing[1].y=wing->jr.y;

	wing->lnwing[0].x=wing->jl.x;
	wing->lnwing[0].y=wing->jl.y+wing->bh;
	wing->rnwing[0].x=wing->jr.x;
	wing->rnwing[0].y=wing->jr.y+wing->bh;


	wing->nlen=nlen;
	wing->flen=flen;
	wing->fnlen=fnlen;
	wing->fflen=fflen;


	wing->sh.mx=shmxang;
	wing->sh.mn=shmnang;

	wing->el.mx=elmxang;
	wing->el.mn=elmnang;

	wing->fb.mx=fbmxang;
	wing->fb.mn=fbmnang;

	wing->ff.mx=ffmxang;
	wing->ff.mn=ffmnang;


/*	wing->fnang=wing->fn.mul*wing->outang+wing->fn.mn;*/

/*	wing->midbase=(wing->fnlen==wing->fflen)?
	((M_PI-(M_PI-wing->fnang))/2):
	atan((wing->fflen*sin(M_PI-wing->fnang))/
	(wing->fnlen+wing->fflen*cos(M_PI-wing->fnang)));*/

	wing->nf.mx=nfmxang;
	wing->nf.mn=nfmnang;


	wing->lwing[0].y1=wing->jl.y;
	wing->lwing[0].x1=wing->jl.x;
	wing->rwing[0].y1=wing->jr.y;
	wing->rwing[0].x1=wing->jr.x;

	return(1); /*don't need this*/
}

int freewings(struct wingset *wing)
{
	if(wing->back!=wing) {
		if(sel==wing) {
			sel=wing->back;
			setui(sel);
		}
		/*are we the last link in the dlist chain?*/
		if(wing->fore) wing->fore->back=wing->back; else
wglob.back=wing->back;
		/*are we the first link in the dlist chain?*/
		if(wing->back->fore) wing->back->fore=wing->fore; else
wglob.fore=wing->fore;
	} else {
		wglob.fore=NULL;
		wglob.back=NULL;
		sel=NULL;
	}
	--dnum;


	g_hash_table_steal(wtable, (gpointer)wing->win);

	if(wing->backbuf) XdbeDeallocateBackBufferName(Xglob.dpy,
wing->backbuf);
	closewin(&wing->win);

	free(wing);

	return(1); /*don't need this*/
}


gint doframe()
{
	struct wingset *wing;

	Display *dpy;
	Drawable draw;
	XdbeSwapInfo swinf;

	swinf.swap_action=XdbeUndefined;

	dpy=Xglob.dpy;
	if(dpy==NULL) IERR;

	wing=wglob.fore;
	while(wing) {

/*		if(!wing->en) { **window not visable**
			wing=wing->fore;
			continue;
		}*/

		genwings(mtime, wing);

/*		draw=wing->backbuf?wing->backbuf:wing->win;*/

/*		XClearWindow(dpy, wing->win);*/
/*		XFillRectangle(dpy, draw, Xglob.cleargc, 0, 0, Xglob.w,
Xglob.h);

		XFillRectangle(dpy, draw, Xglob.gc, wing->bx,
wing->by, wing->bw, wing->bh);

		XFillPolygon(dpy, draw, Xglob.sailgc, wing->lnwing, 6,
Nonconvex, CoordModeOrigin);
		XFillPolygon(dpy, draw, Xglob.sailgc, wing->rnwing, 6,
Nonconvex, CoordModeOrigin);

		XFillPolygon(dpy, draw, Xglob.sailgc, wing->lmwing, 5,
Nonconvex, CoordModeOrigin);
		XFillPolygon(dpy, draw, Xglob.sailgc, wing->rmwing, 5,
Nonconvex, CoordModeOrigin);

		XFillPolygon(dpy, draw, Xglob.sailgc, wing->lfwing, 5,
Nonconvex, CoordModeOrigin);
		XFillPolygon(dpy, draw, Xglob.sailgc, wing->rfwing, 5,
Nonconvex, CoordModeOrigin);

		XDrawSegments(dpy, draw, Xglob.gc, wing->lwing, 8);
		XDrawSegments(dpy, draw, Xglob.gc, wing->rwing, 8);

		swinf.swap_window=wing->win;
		XdbeSwapBuffers(dpy, &swinf, 1);*/
/*		XFlush(dpy);*/

		wing=wing->fore;
	}

	mtime=mtime+aspd;
	mtime=mtime>(2*M_PI)?mtime-2*M_PI:mtime;

	XFlush(dpy);

	return(1);
}


static int genwingvalues(double, struct wingset *);

int genwings(double time, struct wingset *ws)
{
	Display *dpy;
	Drawable draw;
	XdbeSwapInfo swinf;


	if(!ws->en) return(0);

	genwingvalues(time, ws);

	dpy=Xglob.dpy;

	draw=ws->backbuf?ws->backbuf:ws->win;

/*	XClearWindow(dpy, ws->win);*/
	XFillRectangle(dpy, draw, Xglob.cleargc, 0, 0, Xglob.w, Xglob.h);

	XFillRectangle(dpy, draw, Xglob.gc, ws->bx, ws->by, ws->bw, ws->bh);

	XFillPolygon(dpy, draw, Xglob.sailgc, ws->lnwing, 6, Nonconvex,
CoordModeOrigin);
	XFillPolygon(dpy, draw, Xglob.sailgc, ws->rnwing, 6, Nonconvex,
CoordModeOrigin);

	XFillPolygon(dpy, draw, Xglob.sailgc, ws->lmwing, 5, Nonconvex,
CoordModeOrigin);
	XFillPolygon(dpy, draw, Xglob.sailgc, ws->rmwing, 5, Nonconvex,
CoordModeOrigin);

	XFillPolygon(dpy, draw, Xglob.sailgc, ws->lfwing, 5, Nonconvex,
CoordModeOrigin);
	XFillPolygon(dpy, draw, Xglob.sailgc, ws->rfwing, 5, Nonconvex,
CoordModeOrigin);

	XDrawSegments(dpy, draw, Xglob.gc, ws->lwing, 8);
	XDrawSegments(dpy, draw, Xglob.gc, ws->rwing, 8);

	swinf.swap_action=XdbeUndefined;
	swinf.swap_window=ws->win;
	XdbeSwapBuffers(dpy, &swinf, 1);
/*	XFlush(dpy);*/


	return(1);
}

static void scopy(XSegment[], XSegment[], unsigned, unsigned);
static void genstrut(double, double, long, long, XSegment[], XSegment[]);

static int genwingvalues(double time, struct wingset *wing)
{
	unsigned short loop;
	double ang=0;
	double out;
/*This is where C++ "references" would be helpful...  :-(*/

	out=wing->outang=(cos(time)+1)/2;

#define getang(set, out) (((set).mx-(set).mn)*(out)+(set).mn)
	wing->shang=getang(wing->sh, out);
	wing->elang=getang(wing->el, out);
	wing->fbang=getang(wing->fb, out);
	wing->ffang=getang(wing->ff, out);
	wing->nfang=getang(wing->nf, out);
#undef getang


	ang=wing->shang;

	genstrut(wing->shang, wing->elang, wing->nlen, wing->flen,
wing->lwing+0, wing->rwing+0);

	ang+=wing->elang;

	for(loop=2; loop<7; loop+=2) {
		scopy(wing->lwing, wing->rwing, 1, loop);
	}

	wing->leadbase=ang-wing->ffang;
	genstrut(wing->leadbase, -wing->fbang, wing->fnlen, wing->fflen,
wing->lwing+2, wing->rwing+2);

/*If both sections are of equal length finding the offset from vertical
is easy. However if they're of differing lengths its not such a trivial
matter*/
/*	wing->midbase=(wing->fnlen==wing->fflen)?
	((M_PI-(M_PI-wing->fnang))/2):
	atan((wing->fflen*sin(M_PI-wing->fnang))/
	(wing->fnlen+wing->fflen*cos(M_PI-wing->fnang)));*/

	wing->midbase=ang-wing->nfang;
	genstrut(wing->midbase, -wing->fbang, wing->fnlen, wing->fflen,
wing->lwing+4, wing->rwing+4);

	wing->baseang=(wing->leadbase+wing->midbase)/2;
	genstrut(wing->baseang, -wing->fbang, wing->fnlen, wing->fflen,
wing->lwing+6, wing->rwing+6);


/*wing surfaces for filling in*/
	wing->lnwing[2].x=wing->lwing[0].x2;
	wing->lnwing[2].y=wing->lwing[0].y2;
	wing->rnwing[2].x=wing->rwing[0].x2;
	wing->rnwing[2].y=wing->rwing[0].y2;

	wing->lfwing[0].x=wing->lmwing[0].x=wing->lnwing[3].x=wing->lwing[1].x2;
	wing->lfwing[0].y=wing->lmwing[0].y=wing->lnwing[3].y=wing->lwing[1].y2;
	wing->rfwing[0].x=wing->rmwing[0].x=wing->rnwing[3].x=wing->rwing[1].x2;
	wing->rfwing[0].y=wing->rmwing[0].y=wing->rnwing[3].y=wing->rwing[1].y2;

	wing->lmwing[4].x=wing->lnwing[4].x=wing->lwing[4].x2;
	wing->lmwing[4].y=wing->lnwing[4].y=wing->lwing[4].y2;
	wing->rmwing[1].x=wing->rnwing[4].x=wing->rwing[4].x2;
	wing->rmwing[1].y=wing->rnwing[4].y=wing->rwing[4].y2;

	wing->lmwing[3].x=wing->lnwing[5].x=wing->lwing[5].x2;
	wing->lmwing[3].y=wing->lnwing[5].y=wing->lwing[5].y2;
	wing->rmwing[2].x=wing->rnwing[5].x=wing->rwing[5].x2;
	wing->rmwing[2].y=wing->rnwing[5].y=wing->rwing[5].y2;

	wing->lfwing[4].x=wing->lmwing[1].x=wing->lwing[6].x2;
	wing->lfwing[4].y=wing->lmwing[1].y=wing->lwing[6].y2;
	wing->rfwing[1].x=wing->rmwing[4].x=wing->rwing[6].x2;
	wing->rfwing[1].y=wing->rmwing[4].y=wing->rwing[6].y2;

	wing->lfwing[3].x=wing->lmwing[2].x=wing->lwing[7].x2;
	wing->lfwing[3].y=wing->lmwing[2].y=wing->lwing[7].y2;
	wing->rfwing[2].x=wing->rmwing[3].x=wing->rwing[7].x2;
	wing->rfwing[2].y=wing->rmwing[3].y=wing->rwing[7].y2;

	wing->lfwing[1].x=wing->lwing[2].x2;
	wing->lfwing[1].y=wing->lwing[2].y2;
	wing->rfwing[4].x=wing->rwing[2].x2;
	wing->rfwing[4].y=wing->rwing[2].y2;

	wing->lfwing[2].x=wing->lwing[3].x2;
	wing->lfwing[2].y=wing->lwing[3].y2;
	wing->rfwing[3].x=wing->rwing[3].x2;
	wing->rfwing[3].y=wing->rwing[3].y2;

	return(0); /*don't need this*/
}

static inline void gensubstrut(double, long, XSegment[], XSegment[]);
static void genstrut(double ang, double bang, long len, long len2,
XSegment lout[], XSegment rout[])
{
	gensubstrut(ang, len, lout+0, rout+0);
	scopy(lout, rout, 0, 1);
	gensubstrut(ang+bang, len2, lout+1, rout+1);
}

static inline void gensubstrut(double ang, long len, XSegment lout[],
XSegment rout[])
{
	int ty, tx;
	ty=len*cos(ang);
	tx=len*sin(ang);
	lout[0].y2=lout[0].y1+ty;
	lout[0].x2=lout[0].x1-tx;
	rout[0].y2=rout[0].y1+ty;
	rout[0].x2=rout[0].x1+tx;
}

static void scopy(XSegment lseg[], XSegment rseg[], unsigned from,
unsigned to)
{
#define _SCOPY(seg, from, to)	seg[to].y1=seg[from].y2;\
	seg[to].x1=seg[from].x2;

	_SCOPY(lseg, from, to)
	_SCOPY(rseg, from, to)
#undef _SCOPY
}

